(function($) {

    $.gamesRegistry('register', 'drag', new (function() {

	var options = {
	    view_width: Infinity,
	    view_height: Infinity,
	    view_background_img: '',
	    draggable: []
	};

	this.inRightPlaces = 0;

	this.congrats = function() {
	    $('.task-content').addClass('hide');
	    if (snd_instance) {
		snd_instance.stop();
	    }

	    setTimeout(
		function() {
		    $('#congratulation-panel').fadeIn('slow');
		},
		800
		);
	};

	this.makeDroppable = function(obj, dropNo)
	{
	    var that = this;

	    obj.droppable({
		accept: '.drag-item',
		drop: function(event, ui) {

		    if (ui.draggable.hasClass('to-dropzone-no-' + dropNo)) {
			that.inRightPlaces++;

			ui.draggable.hide();
			draggableId = ui.draggable.attr('id')
			$('#dropzone-' + draggableId).show();

			console.log(that.inRightPlaces);
			console.log(options.draggable.length);
			if (that.inRightPlaces === options.draggable.length) {
			    that.congrats();
			}
		    }
		}
	    });
	};

	this.makeDraggable = function(obj)
	{
	    obj.draggable({
		revert: true,
		containment: '#playground',
		start: function() {
		    $(this).addClass('drag-now');
		},
		stop: function() {
		    $(this).removeClass('drag-now')
		}
	    });

	    obj.css('position', 'absolute');

	};

	this.init = function(data, endCallback) {
	    var that = this;
	    $.extend(options, data);

	    var background = preload.getResult(options.view_background_img).src;
	    $('#playground').css('background-image', 'url("' + background + '")');

	    $.each(options.drop_zone, function() {
		var dropZoneItem = $('<div class="drop-zone"></div>');

		area = new absoluteArea(this);
		area.applyAt(dropZoneItem, {
		    view_width: options.view_width,
		    view_height: options.view_height,
		});

		dropZoneItem
		    .attr('title', this.title)
		    .attr('id', 'dropzone-no-' + this.dropzone_no)
		    .css('background-image', 'url("' + preload.getResult(this.image).src + '")');

		that.makeDroppable(dropZoneItem, this.dropzone_no);

		$('#playground').append(dropZoneItem);
	    });

	    $.each(options.draggable, function(key, value) {
		var dragItem = $('<div class="drag-item"></div>');
		var dragItemInsideDropZone = $('<div class="drag-item"></div>');

		area = new absoluteArea(this);
		area.applyAt(dragItem, {
		    view_width: options.view_width,
		    view_height: options.view_height,
		});

		height = parseFloat(dragItem.css('height')) / 2;
		marginBottom = (height * (-1) - 0.7) + '%';

		dragItem.attr('title', this.title);
		dragItem.addClass('to-dropzone-no-' + this.drop_zone);
		dragItem.css('marginBottom', marginBottom);

		that.makeDraggable(dragItem);

		var background = preload.getResult(this.image).src;
		dragItem.css('background-image', 'url("' + background + '")');
		dragItem.attr('id', 'drag-item-' + key);
		dragItemInsideDropZone.attr('title', this.title);
		dragItemInsideDropZone.attr('id', 'dropzone-drag-item-' + key);
		dragItemInsideDropZone.css('background-image', 'url("' + background + '")');
		dragItemInsideDropZone.css('background-repeat', 'no-repeat');
		dragItemInsideDropZone.css('top', this.dropzone_y + '%');
		dragItemInsideDropZone.css('left', this.dropzone_x + '%');
		dragItemInsideDropZone.hide();

		$('#playground').append(dragItem);
		$('#dropzone-no-' + this.drop_zone).append(dragItemInsideDropZone);
	    });

	    setTimeout(function() {
		$('#start-page').fadeOut('slow', function() {
		    $('.task-content').removeClass('hide');
		});
	    }, 500);

	    return this;
	};

	this.resetGame = function()
	{
	    $('.drag-item').remove();
	    $('.drop-zone').remove();
	    this.inRightPlaces = 0;
	};
    })());

})(jQuery);

